-- UIErrorsFrame:AddMessage( "msg" ,0,1,.5,1,2)
-- string.find( UnitDebuff("target",i ), sDebuffName )
-- DEFAULT_CHAT_FRAME:AddMessage( "woot!" )


---------------------------------------------------------------------------------------------------
--- Table Tools --- Table Tools --- Table Tools --- Table Tools --- Table Tools --- Table Tools ---
---------------------------------------------------------------------------------------------------


-- Print contents of `tbl`, with indentation.
-- `indent` sets the initial level of indentation.
function tprint (tbl, indent)
	if not indent then indent = 1 end
	for k, v in pairs(tbl) do
		local formatting = string.rep("  ", indent) .. k .. ": "
		if type(v) == "table" then
			print(formatting)
			tprint(v, indent+1)
		elseif type(v) == 'boolean' then
			print(formatting .. tostring(v))      
		else
			print(formatting .. tostring(v))
		end
	end
end


function initTable(itable,...)
	--print(itable)
	--print(type(itable))
	
	if "table"~=type(itable) then
		error("initTable(itable,...) was not passed a table")
	end

	local n = select("#", ...)
	
	if n>=1 and not itable[select(1,...)] then
		itable[select(1,...)] = {}
	end
	
	if n>=2 and not itable[select(1,...)][select(2,...)] then
		itable[select(1,...)][select(2,...)] = {}
	end
	
	if n>=3 and not itable[select(1,...)][select(2,...)][select(3,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)] = {}
	end
	
	if n>=4 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)] = {}
	end
	
	if n>=5 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)] = {}
	end
	
	if n>=6 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)] = {}
	end
	
	if n>=7 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)] = {}
	end
	
	if n>=8 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)] = {}
	end
	
	if n>=9 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)][select(9,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)][select(9,...)] = {}
	end
	
	--[[
	for i=1, n do
		local arg = select(i, ...)
		
		print(arg)
		itable
	end
	]]--
	
end


function tablelength(T)
	local count = 0
	for _ in pairs(T) do
		count = count + 1
	end
	return count
end




function buildarray(...)
	local arr = {}
	for v in ... do
		---arr[#arr + 1] = v
		table.insert(arr, v)
	end
	return arr
end


---------------------------------------------------------------------------------------------------
------- Text Chat Color ----- Text Chat Color -----  Text Chat Color -----  Text Chat Color -------
---------------------------------------------------------------------------------------------------



 function ColorText(red,green,blue)
 
	-- string representation of colors converted
	if red and not green and not blue then
	
		if string.lower(red) == "orange" then
			red = 255
			green = 102
			blue = 0
			
		elseif string.lower(red) == "maroon" then
			red = 102
			green = 0
			blue = 0
			
			
		elseif string.lower(red) == "poor" then
			red = 157
			green = 157
			blue = 157
			
		elseif string.lower(red) == "common" then
			red = 255
			green = 255
			blue = 255
			
		elseif string.lower(red) == "uncommon" then
			red = 30
			green = 255
			blue = 0
			
		elseif string.lower(red) == "rare" then
			red = 0
			green = 112
			blue = 221
			
		elseif string.lower(red) == "epic" then
			red = 163
			green = 53
			blue = 238
			
		elseif string.lower(red) == "legendary" then
			red = 255
			green = 128
			blue = 0
			
		elseif string.lower(red) == "artifact" or string.lower(red) == "heirloom" then
			red = 230
			green = 204
			blue = 128
			
		end
	end
 
	local red = tonumber( red )
	local green = tonumber( green )
	local blue = tonumber( blue )

	if type(red)=="number" and type(green)=="number" and type(blue)=="number" then
		if red<=0 then red=0 end
		if green<=0 then green=0 end
		if blue<=0 then blue=0 end

		if red<=1 and green<=1 and blue<=1 then
			red = red*256
			green = green*256
			blue = blue*256
		end

		red = round( red )
		green = round( green )
		blue = round( blue )

		if red>=255 then red=255 end
		if green>=255 then green=255 end
		if blue>=255 then blue=255 end

		return "\124cFF"..string.format("%02x%02x%02x", red, green, blue)
	else
		return "\124r"
	end
end


function round(fnumber,rnum)
	if not fnumber then return fnumber end
	if not rnum then rnum=0 end
	local rnum = -1 * rnum
	
	local divnum=10^rnum
	local returnval
	returnval=fnumber/divnum
	returnval=floor(returnval)
	returnval=returnval*divnum
	returnval=tonumber(returnval)
	
	return (returnval)
end



function ScrollToBottom()
    DEFAULT_CHAT_FRAME:ScrollToBottom() 
end


function addMsg(...)
	DEFAULT_CHAT_FRAME:AddMessage(...)
end



-- /script SendChatMessage("Hello Bob!", "WHISPER", "Common", "Bob");

function SendChatMessageInstance(pmsg)
	local inInstance, instanceType = IsInInstance()
	if inInstance then
		SendChatMessage(pmsg,"INSTANCE_CHAT")
	else
		SendChatMessageParty(pmsg)
	end
end

function SendChatMessageParty(pmsg)
	SendChatMessage(pmsg,"PARTY")
end


function SendChatMessageWhisper(pmsg,person)
	SendChatMessage(pmsg,"WHISPER",nil,person)
end






function trim(s)
  return s:match'^()%s*$' and '' or s:match'^%s*(.*%S)'
end






function createColoredArgumentEventString(event,...)

	local argN = select("#",...)
	
	local eventColor 
	
	if event=="COMBAT_LOG_EVENT_UNFILTERED" then
		eventColor = ColorText(0.75,1,0.5)
	else
		eventColor = ColorText(0.5,0.5,1)
	end
	
	local argString = eventColor .. event .. ColorText() .. " " 
	
	for i = 1, argN do
		argString = buildEventFinderString(argString,i,...)
	end
	
	return argString

end



function buildEventFinderString(argString, index, ...)

	local s = select(index,...)
	
	if index==1 and type(s)=='number' and strfind( argString, "COMBAT_LOG_EVENT" ) then
		s=nil
	end
	
	if s or type(s)=='boolean' then
		return argString .. ColorText(255,0,0).."arg"..index.."="..ColorText() .. stringify(s) .. " "
	else
		return argString
	end
	
end


function stringify(s)

	if type(s)=='boolean' then
		if s then
			return "true"
		else
			return "false"
		end
	elseif type(s)=='nil' then
		return "nil"
	elseif type(s)=='table' then
		return "<TABLE>"
	else
		return s
	end
	
end



---------------------------------------------------------------------------------------------------
------ Bank Inventory Containers --- Bank Inventory Containers --- Bank Inventory Containers ------
---------------------------------------------------------------------------------------------------

function scanContainers()

	-- numberOfSlots = GetContainerNumSlots(bagID);
	
	for bagID = 0, NUM_BAG_SLOTS do
		scanContainer(bagID)
	end
	
	--numberOfSlots = GetContainerNumSlots(BANK_CONTAINER);
	--print(numberOfSlots)
	scanContainer(BANK_CONTAINER)

	for bagID = NUM_BAG_SLOTS+1, NUM_BAG_SLOTS+NUM_BANKBAGSLOTS do
		--numberOfSlots = GetContainerNumSlots(bagID);
		--print(numberOfSlots)
		scanContainer(bagID)
	end
end


function scanItems()
	for i=1,65536 do
		--itemId = GetInventoryItemID("unit", invSlot);
		local itemId = GetInventoryItemID("player", i)
		
		processItemId(itemId,"{"..i.."}")
	end
end


function scanContainer(bagID)
	local numberOfSlots = GetContainerNumSlots(bagID);
	--print(numberOfSlots)
	
	for slotID = 1, numberOfSlots do
		local itemId = GetContainerItemID(bagID, slotID);
		
		processItemId(itemId, "[" .. bagID .. "," .. slotID .. "]")
	end
end



function processItemId(itemId,msg)
	if itemId then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId)

		if itemRarity==1 or itemRarity==2 or itemRarity==3 or itemRarity==4 then
			-- ignore
		elseif itemRarity==0 then
			print(msg .. "  " .. itemName .. "   <" .. itemRarity .. ">")
		else
			print(ColorText(255,0,0) .. msg .. "  " .. itemName .. "   <" .. itemRarity .. ">" .. ColorText())
		end
	end

end





function TableOfInventory()
	
	local inventoryTable = {}
	
		for i=1,39 do
			local itemId = GetInventoryItemID("player", i)
			
			if itemId then
				local itemLink = GetInventoryItemLink("player", i)
				inventoryTable["{"..i.."}"] = { itemId=itemId , count=1, itemLink=itemLink }
			end
		end
	
	for bagID = 0, NUM_BAG_SLOTS do
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end
	end
	
	local bagID = BANK_CONTAINER
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end

	for bagID = NUM_BAG_SLOTS+1, NUM_BAG_SLOTS+NUM_BANKBAGSLOTS do
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end
	end
	
	-- reagent bank slots
	local bagID = -3
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end

	return inventoryTable
end



function parseTableForHeirlooms()

	local toInventory = TableOfInventory()
	
	local heirTable = {}
	
	local count = 0
	
	--tprint(toInventory)
	
	for k in pairs(toInventory) do
		local data = toInventory[k]
		--tprint(data)
		local itemId = data.itemId
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId)
		
		if itemRarity==0 or itemRarity==1 or itemRarity==2 or itemRarity==3 or itemRarity==4 then
			-- ignore
			
		else
			--print( k .. "  " .. itemLink .. "   <" .. itemRarity .. ">" )
			count = count + 1
			heirTable[k] = itemName
			
		end
	end
	
	--print("Heirlooms found: " .. ColorText(255,0,0) .. count .. ColorText())
	
	return heirTable, count

end





function listGear()

	print(ColorText(255,102,0).."Listing Gear by Level:")

	local gearTable = {}

	for i=0,18 do

		if i ~= 4 then -- skip shirt
			local iitemLink = GetInventoryItemLink("player", i)
			
			if iitemLink then
				local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(iitemLink)
			
				table.insert(gearTable,{itemLink,itemLevel + itemRarity/10 , itemLevel})
			end
		end
		
	end
	
	
	local function compare(a,b)
		return a[2] > b[2]
	end
	
	table.sort(gearTable,compare)
	
	
	--tprint(gearTable)
	
	
	for key,value in pairs(gearTable) do
	
		print("  " .. value[3] .. "  " .. value[1])
	
	end
	
	ScrollToBottom()

end


listgear = listGear





---------------------------------------------------------------------------------------------------
----- Start Combat Aggro --- Start Combat Aggro --- Start Combat Aggro --- Start Combat Aggro -----
---------------------------------------------------------------------------------------------------




function numberPartyInCombat()
	local s = 0
	local who = nil

	for i = 0, 8 do
		local partyI = "party"..i
		local affectingCombat = UnitAffectingCombat(partyI);
		if affectingCombat then
			s = s + 1
			
			if who==nil then
				who = GetUnitName(partyI,true)
			else
				who = who .. ", " .. GetUnitName(partyI,true)
			end
		end
	end
	
	local partyI = "player"
	local affectingCombat = UnitAffectingCombat(partyI);
	if affectingCombat then
			s = s + 1
			
			if who==nil then
				who = GetUnitName(partyI,true)
			else
				who = who .. ", " .. GetUnitName(partyI,true)
			end
	end
	
	return s, who
end










---------------------------------------------------------------------------------------------------
------- Group Roles ----- Group Roles ----- Group Roles ----- Group Roles ----- Group Roles -------
---------------------------------------------------------------------------------------------------


function whoHealer()
	local s = 0
	local who = {}

	for i = 0, 8 do
		local partyI = "party"..i
		local role = UnitGroupRolesAssigned(partyI);
		if "HEALER"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	end
	
		local partyI = "player"
		local role = UnitGroupRolesAssigned(partyI);
		if "HEALER"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	
	return s, who
end



function whoTank()
	local s = 0
	local who = {}

	for i = 0, 8 do
		local partyI = "party"..i
		local role = UnitGroupRolesAssigned(partyI);
		if "TANK"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	end
	
		local partyI = "player"
		local role = UnitGroupRolesAssigned(partyI);
		if "TANK"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	
	return s, who
end



function GetNumMembers()

	--[[
	local members = GetNumRaidMembers();
	
	if members==nil then
		members = -1
	end
	
	local partyMembers = GetNumPartyMembers()
	
	if partyMembers==nil then
		partyMembers = -1
	end
	
	if members > partyMembers then
		return members
	else
		return partyMembers
	end
	]]--
	
	return GetNumGroupMembers();

end





---------------------------------------------------------------------------------------------------
----- Party Raid Markers --- Party Raid Markers --- Party Raid Markers --- Party Raid Markers -----
---------------------------------------------------------------------------------------------------



-- /script if not GetRaidTargetIndex("target") then SetRaidTarget("target",7) end

function AutoPartyRaidTargetMarkers()

	for i = 0, 8 do
		local partyI = "party"..i
		AutoRaidTargetMarkMember(partyI)
	end
	
		AutoRaidTargetMarkMember("player")
	
end



function AutoRaidTargetMarkMember(memberID)
	
	if not GetRaidTargetIndex(memberID) then
	
		local role = UnitGroupRolesAssigned(memberID);
		
		if "TANK" == role then
		
			SetRaidTarget(memberID,1)
		
		elseif "HEALER" == role then
		
			SetRaidTarget(memberID,5)
		
		end
	
	end
	
end




function CycleRaidTargetMarker(unit)

	cycleRaidTargetMarkerIndex = cycleRaidTargetMarkerIndex or 1
	
	if UnitExists(unit) then
	
		SetRaidTarget(unit,cycleRaidTargetMarkerIndex)
		
		cycleRaidTargetMarkerIndex = 1 + cycleRaidTargetMarkerIndex
		
		if cycleRaidTargetMarkerIndex>6 then
			cycleRaidTargetMarkerIndex = nil
		end
	
	end

end


---------------------------------------------------------------------------------------------------
---- Zone Info Text --- Zone Info Text --- Zone Info Text --- Zone Info Text --- Zone Info Text ---
---------------------------------------------------------------------------------------------------


function zoneInfo()
	
	local zoneName = GetZoneText();
	local subzone = GetSubZoneText();
	local minimapzonetext = GetMinimapZoneText();
	
	return ( zoneName .. " | " .. subzone .. " | " .. minimapzonetext )
end












---------------------------------------------------------------------------------------------------
---- Macro Helpers ---- Macro Helpers ---- Macro Helpers ---- Macro Helpers ---- Macro Helpers ----
---------------------------------------------------------------------------------------------------


function xtarget(markNumber)
	if not markNumber then
		markNumber = 7
	end
	if UnitExists("target") and not GetRaidTargetIndex("target") then
		SetRaidTarget("target",markNumber)
	end
end





function DoEmoteOOM()
	DoEmote("OOM")
end







function QuadSafeEndCinematic()

	if xtimer("TripleSafeEndCinematic_1",2) then
		return 1
	end
	if xtimer("TripleSafeEndCinematic_2",2) then
		return 2
	end
	if xtimer("TripleSafeEndCinematic_3",2) then
		return 3
	end
	
	if xtimer("QuadSafeEndCinematic() StopCinematic()",3) then
		print( "QuadSafeEndCinematic()  " .. stringify(InCinematic()) )
		
		StopCinematic()
	end

end







local waitTable = {};
local waitFrame = nil;

function oom__wait(delay, func, ...)
	if(type(delay)~="number" or type(func)~="function") then
		return false;
	end
	
	if(waitFrame == nil) then
		waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
		waitFrame:SetScript("onUpdate",
			function (self,elapse)
				local count = #waitTable;
				local i = 1;
				while(i<=count) do
					local waitRecord = tremove(waitTable,i);
					local d = tremove(waitRecord,1);
					local f = tremove(waitRecord,1);
					local p = tremove(waitRecord,1);
					if(d>elapse) then
						tinsert(waitTable,i,{d-elapse,f,p});
						i = i + 1;
					else
						count = count - 1;
						f(unpack(p));
					end
				end
			end
		);
	end
	tinsert(waitTable,{delay,func,{...}});
	return true;
end



function cycleGuildBankTab()

	if not curTab then
		curTab = 1
	end
	
	if curTab==1 then
		GuildBankTab1Button:Click()
		
	elseif curTab==2 then
		GuildBankTab2Button:Click()
		
	elseif curTab==3 then
		GuildBankTab3Button:Click()
		
	elseif curTab==4 then
		GuildBankTab4Button:Click()
		
	elseif curTab==5 then
		GuildBankTab5Button:Click()
		
	elseif curTab==6 then
		GuildBankTab6Button:Click()
		
	end
	
	curTab = 1 + curTab
	
	if curTab>6 then
		curTab = nil
	end

end


---------------------------------------------------------------------------------------------------
--- Professions --- Professions --- Professions --- Professions --- Professions --- Professions ---
---------------------------------------------------------------------------------------------------

function printProfessions()

	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	
	if not firstAid then
		firstAid = ""
	end
	
	if not archaeology then
		archaeology = ""
	end
	
	print(prof1 .. " " .. prof2 .. " " .. archaeology .. " " .. fishing .. " " .. cooking .. " " .. firstAid )
	
	local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof1)
	print(name .. " " .. skillLevel .. " " .. maxSkillLevel )
	
	
	local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof2)
	print(name .. " " .. skillLevel .. " " .. maxSkillLevel )
	
end




function TableOfProfessions()

	local profTable = {}

	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	
	if prof1 then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof1)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if prof2 then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof2)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if archaeology then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(archaeology)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if fishing then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(fishing)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if cooking then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(cooking)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if firstAid then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(firstAid)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	return profTable
	
--	if table.getn(profTable)>0 then
--		return profTable
--	else
--		return nil
--	end
end




---------------------------------------------------------------------------------------------------
------- Frames --- Frames --- Frames --- Frames --- Frames --- Frames --- Frames --- Frames -------
---------------------------------------------------------------------------------------------------


--- PrintFramesRegisteredForEvent("PLAYERBANKSLOTS_CHANGED")
--- PrintFramesRegisteredForEvent("PLAYERBANKBAGSLOTS_CHANGED")

function PrintFramesRegisteredForEvent(evt)

	local num = select( "#", GetFramesRegisteredForEvent(evt) )
	print(ColorText(1,0,0)..num)
	for i = 1, num do
		local s = select( i, GetFramesRegisteredForEvent(evt) )
		print(ColorText(0,1,0)..i)
		print( s:GetName() )
	end

end



function BankFrameIsVisible()
	return BankFrame:IsVisible()
end


function LossOfControlFrameIsVisible()
	return LossOfControlFrame:IsVisible()
end


--[[
/run PrintParentFrameList(CharacterBag0Slot)
--]]

function PrintParentFrameList(frm)

	local f = frm
	
	for i =1, 100 do
	
		if f then
			print( i .. "  " .. ColorText(1,.5,.5) .. f:GetName() )
		end
		
		if f:GetParent() then
			f = f:GetParent()
		else
			break
		end
	end

	print( "^" .. "  " .. ColorText(1,.5,.5) .. f:GetName() )
end

--[[
/run PrintChildFrame(LossOfControlFrame)
--]]

function PrintChildFrame(frm,depth)

	if not frm then
		return
	end
	
	if not frm:GetName() then
		print( tostring(frm) .. "  " .. ColorText(0.5,1,0.5) .. select('#', frm:GetChildren() ) )
		return
	end

	if not depth then
		depth = 0
	end
	
	if depth > 2 then
		return
	end
	
	print( depth .. "  " .. ColorText(1,0.5,0.5) .. frm:GetName() .. ColorText() .. "  " .. ColorText(0.5,1,0.5) .. select('#', frm:GetChildren()) .. ColorText() )

	PrintChildFrameR( depth, frm:GetChildren() )
	--[[
	for cf in frm:GetChildren() do
		PrintChildFrame( cf, depth+1 )
	end
	]]--
end



function PrintChildFrameR(depth, ...)

	local s = select("#",...)
	--print("select# = " .. ColorText(0.5,0.5,1) .. s )
	
	for i = 1, s do
	
		local f = select(i,...)
				
		PrintChildFrame( f, depth+1 )
		
	end
	
end





---------------------------------------------------------------------------------------------------
------- Quests --- Quests --- Quests --- Quests --- Quests --- Quests --- Quests --- Quests -------
---------------------------------------------------------------------------------------------------




function DICQ(questid)

	-- remove all non-digit characters from string
	local numbersOnly = string.gsub(questid,"[^%d]","")

	return DidICompleteQuest(numbersOnly)
end

function DidICompleteQuest(questid)

	local questid = tonumber(questid)

	local questtable = { GetQuestsCompleted() }
	
	--print(type(questtable))
	
	if questid then
		print("Looking for Quest ID: " .. ColorText(0.5,0.5,1) .. questid)

		for key1,value1 in pairs(questtable) do
			--print( "key1 " .. key1 ) 
			for key2,value2 in pairs(value1) do
				--print("key2 " ..key2)
				
				if key2 == questid then
					print("Quest Completed: " .. ColorText(0.5,1,0.5).. key2)
					return true
				end
				
			end
		end
		
		print("Quest Not found: " .. ColorText(1,0.5,0.5).. tostring(questid))
	
	else
	
		print("Displaying All Quests:")
		
		local questCount = 0
		
		local bigstring = ""
		
		for key1,value1 in pairs(questtable) do
			for key2,value2 in pairs(value1) do
				--print(key2)
				
				bigstring = bigstring .. " " .. key2
				
				if string.len(bigstring) > 255 then
					print(bigstring)
					bigstring = ""
				end
				
				questCount = 1 + questCount
				
			end
		end
		
		print( bigstring )
		
		print("Number Quests Completed: " .. ColorText(0.5,0.5,1) .. questCount)
	
	end
	
	ScrollToBottom()
	
end



--[[

#showtooltip Healing Wave
/script UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")
/cast reinforce
/cast empower
/script UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE")
/cast healing wave
]]--


function shareAllQuests(delay)
	delay = delay or 0.075

	print(ColorText(255,102,0).."Sharing All Quests...")
	
	local questGreenRange = UnitLevel("player") - GetQuestGreenRange()

	local questTable = {}

	local i = 1;
	while true do
		
		if GetQuestLogTitle(i)==nil then
			break
		end
		
		local title, level, tag, header = GetQuestLogTitle(i);
		
		if not header and level >= questGreenRange then
		
			SelectQuestLogEntry(i);
			
			if GetQuestLogPushable() then
				table.insert(questTable, {i,level,title} )
				--print(i .. "  " .. level .. "  " .. title)
			end
			
		end
		
		i = i + 1;
	end
	
	
	local function compare(a,b)
		return a[2] > b[2]
	end
	
	table.sort(questTable,compare)
	
	local j = 0
	for key,value in pairs(questTable) do
		local v_i = value[1]
		local v_level = value[2]
		local v_title = value[3]
		
		local title, level, tag, header = GetQuestLogTitle(v_i);
		
		print("  " .. v_level .. "  " .. v_title )
		
		local function delayShareQuest()
			SelectQuestLogEntry(v_i);
			QuestLogPushQuest();
		end
		
		oom__wait(j,delayShareQuest)
		j = delay + j
	end
	
	ScrollToBottom()

end

shareallquests = shareAllQuests


---------------------------------------------------------------------------------------------------
--------- Mount Speed ---- Mount Speed ---- Mount Speed ---- Mount Speed ---- Mount Speed ---------
---------------------------------------------------------------------------------------------------


function GetMountSpeed()

    if GetSpellInfo("Flight Master's License") then
        Flight_Masters_License = "Flight Master's License"
    end
    
    if GetSpellInfo("Cold Weather Flying") then
        Cold_Weather_Flying = "Cold Weather Flying"
    end
    
    if GetSpellInfo("Wisdom of the Four Winds") or GetSpellInfo("Grimoire of the Four Winds") then
        Wisdom_of_the_Four_Winds = "Wisdom of the Four Winds"
    end
    
    maxRiding = nil

    if GetSpellInfo("Master Riding") then
        maxRiding = "Master Riding"
    elseif GetSpellInfo("Artisan Riding") then
        maxRiding = "Artisan Riding"
    elseif GetSpellInfo("Expert Riding") then
        maxRiding = "Expert Riding"
    elseif GetSpellInfo("Journeyman Riding") then
        maxRiding = "Journeyman Riding"
    elseif GetSpellInfo("Apprentice Riding") then
        maxRiding = "Apprentice Riding"
    else
        maxRiding = nil
    end
    
    return maxRiding, Flight_Masters_License, Cold_Weather_Flying, Wisdom_of_the_Four_Winds  
end


---------------------------------------------------------------------------------------------------
------- Notes & TODO ---- Notes & TODO ---- Notes & TODO ---- Notes & TODO ---- Notes & TODO ------
---------------------------------------------------------------------------------------------------


-- fix "escape key" to exit cinematic
-- list gear by ilvl



-- share all quests (share highest lvl first) (bonus to group quests?)



-- BattleGround assist add-on

-- add slash commands for listgear and shareallquests functions

-- add ignore list for shareAllQuests
